%This code requires the "MATLAB Support Package for Arduino Hardware"

close all
clear all
clc

a=arduino;                          % Connect to an Arduino Uno
DATA=[];                            % an empty vector to save the acquired EMG signal values
Start=0;                            % to determine the beginig of acquiring the EMG signal
Finish=0;                           % to determine the end of acquiring the EMG signal
threshold=0.0099;                   % Threshold below which values are considered a noise signals 
ranking={'First Movement';'Second Movement';'Third Movement'};
while (1)
    Signal=[];                      % an empty vector to save the entire acquired signal 
    u=a.readVoltage('A2');          % A2 is the input port of Arduino Uno where the output of the EMG sensor should be connected
    if u>threshold              
        DATA=[DATA,u];
        Start=1;
        Finish=1;
    end
    if Start==1&&Finish==0
         if numel(DATA)>3
            Signal=[DATA,0];
            DATA=[];
         end
        Start=0;
    end
    Finish=0;     
 % Recognitions Stage
    if numel(Signal)>10
        x1=ExponentialModel(Signal);      % Modeling the acquired signal with a exponential model
        x2=GaussianModel(Signal);         % Modeling the acquired signal with a gaussian model
        x3=FractionalModel(Signal);       % Modeling the acquired signal with a fractional model       
        [q , j]=max([x1,x2,x3]);
        if q>.9
            if j==1
                writePWMVoltage(a,'D5',1.14);  % Write digital pin PWM voltage value 1.14 volt D5 is where the input of the proportional valve should be connected
            elseif j==2
                writePWMVoltage(a,'D5',2.14); % Write digital pin PWM voltage value 2.14 volt D5 is where the input of the proportional valve should be connected
            else
                writePWMVoltage(a,'D5',3.55); % Write digital pin PWM voltage value 3.55 volt D5 is where the input of the proportional valve should be connected
            end
                ranking(j,:)
         else 
            writePWMVoltage(a,'D5',0);    % Write digital pin PWM voltage value 0 volt, when the recognized movement is an unwanted movement 
            disp('Unwanted Movement')
        end
    end
end 

% Note: Press Ctrl + C upon finishing of signal acquisition
